package com.zksy.web.controller.basicData;


import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.TypeReference;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.zksy.common.annotation.Log;
import com.zksy.common.core.controller.BaseController;
import com.zksy.common.core.domain.AjaxResult;
import com.zksy.common.enums.BusinessType;
import com.zksy.common.utils.file.ExcelUtils;
import com.zksy.system.basicData.domain.CrmEnterpriseInformation;
import com.zksy.system.basicData.service.CrmEnterpriseInformationService;
import com.zksy.utils.DowntemplateUtil;
import com.zksy.utils.EnterpriseExcelUtil;
import com.zksy.utils.SearchUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;
import java.util.Map;

/**
 * 企业信息Controller
 *
 * @author sy
 * @date 2024-04-17
 */
@RestController
@RequestMapping("/crmEnterpriseInformation")
@Api(tags = "企业信息", description = "企业信息desc")
public class CrmEnterpriseInformationController extends BaseController {

    @Autowired
    private CrmEnterpriseInformationService service;

    @GetMapping("/getById/{borrowId}")
    @ApiOperation(value = "企业信息搜索getById")
    public AjaxResult getById(@PathVariable String borrowId) {
        return AjaxResult.success(service.getById(borrowId));
    }

    @GetMapping("/findByPage")
    @ApiOperation(value = "企业信息分页")
    public Page findByPage(long pageNum, long pageSize, String conditionJson) throws Exception {
        return service.page(new Page<>(pageNum, pageSize), SearchUtil.parseWhereSql(conditionJson));
    }

    @GetMapping("/getList")
    @ApiOperation(value = "企业信息查询所有")
    public AjaxResult getList(String conditionJson) throws Exception {
        return AjaxResult.success(service.list(SearchUtil.parseWhereSql(conditionJson)));
    }

    /**
     * 新增企业信息
     */
    @PostMapping("/save")
    @ApiOperation(value = "企业信息新增")
    @Log(title = "新增企业信息", businessType = BusinessType.INSERT)
    public boolean save(@RequestBody CrmEnterpriseInformation crmEnterpriseInformation) {
        return service.save(crmEnterpriseInformation);
    }

    /**
     * 修改企业信息
     */
    @PostMapping("/updateById")
    @ApiOperation(value = "企业信息修改")
    @Log(title = "修改企业信息", businessType = BusinessType.UPDATE)
    public boolean updateById(@RequestBody CrmEnterpriseInformation crmEnterpriseInformation) {
        return service.updateById(crmEnterpriseInformation);
    }

    /**
     * 导入企业信息
     */
    @ApiOperation("企业信息导入")
    @Log(title = "企业信息", businessType = BusinessType.IMPORT)
    @PostMapping("/importData")
    public AjaxResult importData(MultipartFile file)
    {
        try {
            List<CrmEnterpriseInformation> crmEnterpriseInformationAll = service.list();
            if(crmEnterpriseInformationAll != null && crmEnterpriseInformationAll.size() > 0){
                //return AjaxResult.error("数据已存在，如需重新导入请清空数据");
            }
            //excel单元格合并导入
            //参数：文件， 表头列数， 是否读取序号0-读取、1-不读取， 表头占的行数下标从0开始的
            List<Map<String,String>> list = EnterpriseExcelUtil.readExcelToObj(file, CrmEnterpriseInformation.class.getDeclaredFields().length - 2,1,3,CrmEnterpriseInformation.class);
            List<CrmEnterpriseInformation> accOutCaseHelpExamList= JSON.parseObject(JSON.toJSONString(list), new TypeReference<List<CrmEnterpriseInformation>>() {});

            if(list.size() > 0){
                service.saveBatch(accOutCaseHelpExamList);
                return success("导入成功，共计："+list.size()+"条");
            }else{
                return AjaxResult.error("无数据");
            }
        }catch (Exception e){
            e.printStackTrace();
            return AjaxResult.error("导入数据失败");
        }
    }

    @ApiOperation("企业信息导出")
    @Log(title = "企业信息", businessType = BusinessType.EXPORT)
    @PostMapping("/exportData")
    public AjaxResult exportData(HttpServletResponse response, String conditionJson){
        try {
            List<CrmEnterpriseInformation> wrapperList = service.list(SearchUtil.parseWhereSql(conditionJson));
            ExcelUtils.export(response,"企业信息",wrapperList,CrmEnterpriseInformation.class);
            return AjaxResult.success("导出数据成功");
        }catch (Exception e){
            e.printStackTrace();
            return AjaxResult.error("导出数据失败");
        }
    }

    @Log(title = "企业信息", businessType = BusinessType.DELETE)
    @PostMapping("/delete")
    @ApiOperation(value = "删除企业信息", notes = "删除企业信息")
    public AjaxResult delete(@RequestBody List<String> ids)
    {
        return toAjax(service.removeByIds(ids));
    }

    @DeleteMapping("/deleteAll")
    @ApiOperation(value = "清除数据", notes = "清除数据")
    public AjaxResult deleteAll(){
        return service.deleteAll();
    }

    @PostMapping("/getUploadTemplate")
    @ApiOperation(value = "获取上传模板", notes = "获取上传模板")
    public void getUploadTemplate(HttpServletResponse response) throws IOException {
        DowntemplateUtil.downloadTemplate(response,"企业信息一览表模板");
    }
}

